SystemOrganization addCategory: #VisibilityProfiler!

Profiler subclass: #VisibilityProfiler
	instanceVariableNames: 'externalCallerMethodThreshold externalCallerMethodFactorThreshold'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfiler class methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
spyClassForPackage
	 ^ VisibilityProfilerPackage! !

!VisibilityProfiler methodsFor: 'gettersAndSetters' stamp: 'SantiagoVidal 5/1/2012 18:52'!
externalCallerMethodFactorThreshold
	 ^externalCallerMethodFactorThreshold! !

!VisibilityProfiler methodsFor: 'gettersAndSetters' stamp: 'SantiagoVidal 5/1/2012 18:52'!
externalCallerMethodFactorThreshold:aNumber
	externalCallerMethodFactorThreshold:=aNumber.! !

!VisibilityProfiler methodsFor: 'gettersAndSetters' stamp: 'SantiagoVidal 5/1/2012 18:50'!
externalCallerMethodThreshold
	^externalCallerMethodThreshold.! !

!VisibilityProfiler methodsFor: 'gettersAndSetters' stamp: 'SantiagoVidal 5/1/2012 18:49'!
externalCallerMethodThreshold: aNumber
	externalCallerMethodThreshold:=aNumber.! !

!VisibilityProfiler methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/2/2012 12:40'!
initialize
	externalCallerMethodThreshold:=4.
	externalCallerMethodFactorThreshold:=2.! !

!VisibilityProfiler methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
registryName
	^ #VisibilityProfiler! !

!VisibilityProfiler methodsFor: 'visualization' stamp: 'SantiagoVidal 5/1/2012 16:59'!
visualizeOn: view
	view nodes: self allClasses forEach: [ :each | 
		view shape rectangle borderColor:  [:m | m isPrivate ifTrue: [ Color black ] ifFalse: [ m isProtected ifTrue: [Color orange] ifFalse: [m isPrivateWithTests ifTrue: [Color lightGray] ifFalse:[m isABadEncapsulationCandidate ifTrue: [Color red] ifFalse: [Color green]]] ]].
		view nodes: each methods.
		view gridLayout gapSize: 2.
	].
	view edgesFrom: #superclass.
	view treeLayout
	! !

MethodSpy subclass: #VisibilityProfilerMethod
	instanceVariableNames: 'callerMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerMethod methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:51'!
beforeRun: methodName with: listOfArguments in: receiver
	callerMethods add:(self callingMethod).
	! !

!VisibilityProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/30/2012 19:47'!
callerMethods
	^callerMethods.! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/1/2012 10:48'!
findNumberOfExternalCallerMethods
	^ callerMethods inject: 0 into: [ :result :m | ( (m methodClass == self theClass) |( self theClass subclasses includes: (m methodClass) ) )ifTrue:[result+0] ifFalse: [result+1].]! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/2/2012 12:54'!
getInternalCallerMethods
	"This method gets all the methods that calls this methods from its own class (or are in the hierarchy)."
	^ callerMethods inject: OrderedCollection new into: [ :result :m | ( (m methodClass == self theClass) or:( self theClass subclasses includes: (m methodClass) ) )ifTrue:[result add:m; yourself ] ifFalse: [result].]! !

!VisibilityProfilerMethod methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 4/30/2012 17:56'!
initialize
	super initialize.
	callerMethods:=IdentitySet new.! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/1/2012 19:10'!
isABadEncapsulationCandidate
	"It is a candidate if it is a public method that is called for a few external methods and at least an inner method that has more external methods as caller"
	|externalCallerMethodThreshold externalCallerMethodFactorThreshold|
	externalCallerMethodThreshold:=self profiler externalCallerMethodThreshold.
	externalCallerMethodFactorThreshold:=self profiler externalCallerMethodFactorThreshold.
	self isPublic ifTrue: [
		|numberOfexternalCallerMethods|
		numberOfexternalCallerMethods:=self findNumberOfExternalCallerMethods.
		(numberOfexternalCallerMethods <externalCallerMethodThreshold) ifTrue: [
			|internalCallerMethods|
			
			internalCallerMethods:=self getInternalCallerMethods.
			(internalCallerMethods size >0)ifTrue: [
					internalCallerMethods do:[:anInternalCaller|
						|internalCallerSpyMethod|
						internalCallerSpyMethod:=(self spyMethod:anInternalCaller).
						(internalCallerSpyMethod ==nil) ifFalse:[
						(internalCallerSpyMethod findNumberOfExternalCallerMethods >(numberOfexternalCallerMethods*externalCallerMethodFactorThreshold)) ifTrue: [^true].]
					].
			].
		].
	].
	^false.! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/2/2012 13:14'!
isABadEncapsulationCandidateWithInterMethods: aNumberOfInterMethods
	"It is a candidate if it is a public method that is called for a few external methods and at least an inner method that has more external methods as caller"
	|externalCallerMethodThreshold externalCallerMethodFactorThreshold|
	externalCallerMethodThreshold:=self profiler externalCallerMethodThreshold.
	externalCallerMethodFactorThreshold:=self profiler externalCallerMethodFactorThreshold.
	self isPublic ifTrue: [
		|numberOfexternalCallerMethods|
		numberOfexternalCallerMethods:=self findNumberOfExternalCallerMethods.
		(numberOfexternalCallerMethods <externalCallerMethodThreshold) ifTrue: [
			|internalCallerMethods interMethodsRemaining|
			
			internalCallerMethods:=self getInternalCallerMethods.
			interMethodsRemaining:=aNumberOfInterMethods.
			(interMethodsRemaining>0)whileTrue: [
				|notPubicMethods|
				"Filtro solo los metodos que no sean publicos"
				notPubicMethods:=OrderedCollection new.
				internalCallerMethods do:[:anInternalCaller|
					|spyMethod|
					spyMethod:=(self spyMethod:anInternalCaller).
					spyMethod isPublic isFalse: [
						notPubicMethods add: spyMethod.
					].
				].
				"Cambio el internalCallerMethods por todos los metodos internos que llamaban a los notPublic"
				internalCallerMethods:=OrderedCollection new.
				notPubicMethods do:[:aNotPublicMethod|
					internalCallerMethods addAll: aNotPublicMethod getInternalCallerMethods.
				].
				interMethodsRemaining:=interMethodsRemaining-1.
			].
			
			(internalCallerMethods size >0)ifTrue: [
					internalCallerMethods do:[:anInternalCaller|
						|internalCallerSpyMethod|
						internalCallerSpyMethod:=(self spyMethod:anInternalCaller).
						(internalCallerSpyMethod ==nil) ifFalse:[
						(internalCallerSpyMethod findNumberOfExternalCallerMethods >(numberOfexternalCallerMethods*externalCallerMethodFactorThreshold)) ifTrue: [^true].]
					].
			].
		].
	].
	^false.! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/1/2012 09:36'!
isPrivate
	"A method is private if it is called only by methods of its own class or if it is not called for any method"
	^ callerMethods inject: true into: [ :result :m |  result and: [ m methodClass == self theClass ]]
	! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/1/2012 17:02'!
isPrivateWithTests
	(self isPrivate | self isProtected )ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  (((result and: [ m methodClass == self theClass ]) or: ([ self theClass subclasses includes: (m methodClass) ] ) )or: [m methodClass inheritsFrom:TestCase ])]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 4/30/2012 19:07'!
isProtected
	self isPrivate ifTrue: [^false].
	^ callerMethods inject: true into: [ :result :m |  (result and: [ m methodClass == self theClass ]) or: [ self theClass subclasses includes: (m methodClass) ]]! !

!VisibilityProfilerMethod methodsFor: 'kindOfMethod' stamp: 'SantiagoVidal 5/1/2012 16:57'!
isPublic
	self isPrivate ifTrue: [^false].
	self isProtected ifTrue: [^false].
	self isPrivateWithTests ifTrue: [^false].
	^true.! !

!VisibilityProfilerMethod methodsFor: 'badEncapsulations' stamp: 'SantiagoVidal 5/1/2012 11:52'!
spyMethod: aCompileMethod

	self profiler allMethods do:[:anSpyMethod|
		
	((aCompileMethod methodClass == anSpyMethod theClass) &(aCompileMethod selector ==anSpyMethod selector))ifTrue: [^anSpyMethod].
	].
	^nil.
	"el metodo spy que consiga compiledMethod==aCompileMethod"! !

AbstractSpyTest subclass: #VisibilityProfilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerTest methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
profilerClass
	^  VisibilityProfiler! !

!VisibilityProfilerTest methodsFor: 'tests' stamp: 'SantiagoVidal 5/1/2012 09:43'!
testPrivateMethod
	|methods|
	methods:=self runScenario allMethods.
	
	"Private method with 3 callers <TGFoo>>foo1>"
	self assert: (methods at:66) isPrivate.
	
	"Private method with 2 callers <TGFoo>>foo3>"
	self assert: (methods at:61) isPrivate.
	
	"Private method with 0 callers <TGFooSubClass2>>indirectSideEffect:>"
	self assert: (methods at:2) isPrivate.
	
	! !

!VisibilityProfilerTest methodsFor: 'tests' stamp: 'SantiagoVidal 5/1/2012 17:06'!
testPrivateWithTestsMethod
	|methods|
	methods:=self runScenario allMethods.
	
	"<TGCar>>addWheel:> called for tests and classes"
	self assert: (methods at:15) isPrivateWithTests.
	"<TGCar>>driver:> called only for tests"
	self assert: (methods at:16) isPrivateWithTests.
	! !

!VisibilityProfilerTest methodsFor: 'tests' stamp: 'SantiagoVidal 5/1/2012 09:55'!
testProtectedMethod
	|methods|
	methods:=self runScenario allMethods.
	
	"There is not a scenario with a protectred method"
	"Private method with 2 callers <TGFoo>>initialize>"
	
	"self assert: (methods at:59) isProtected."
	
! !

!VisibilityProfilerTest methodsFor: 'tests' stamp: 'SantiagoVidal 5/1/2012 17:05'!
testPublicMethod
	|methods|
	methods:=self runScenario allMethods.
	
	
	"<TGCar>>hash> called only for classes but one of them is a false dependency"
	self assert: (methods at:11) isPublic.
	"<TGCar>>giveMeANewCarForDriver:> called only for classes"
	self assert: (methods at:13) isPublic.! !

PackageSpy subclass: #VisibilityProfilerPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerPackage class methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
spyClassForClass
	 ^ VisibilityProfilerClass! !

ClassSpy subclass: #VisibilityProfilerClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!VisibilityProfilerClass class methodsFor: 'hooks' stamp: 'SantiagoVidal 4/30/2012 17:06'!
spyClassForMethod
	 ^ VisibilityProfilerMethod! !

Object subclass: #CaseStudies
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'VisibilityProfiler'!

!CaseStudies methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 5/2/2012 12:37'!
createAreaChartData
|profiler methods|
profiler:=VisibilityProfiler runTestsForPackagesMatching: 'Roassal*'.
methods:=profiler allMethods.
2 to: 20 do:[:externalCallerMethodThreshold|
	|externalCallerMethodFactorThreshold|
	externalCallerMethodFactorThreshold:=1.
	[externalCallerMethodFactorThreshold<=3.1] whileTrue: [
		|problemsDetected|
		"Transcript show: externalCallerMethodThreshold asString, ' ', externalCallerMethodFactorThreshold asString; cr."
		profiler externalCallerMethodThreshold:externalCallerMethodThreshold.
		profiler externalCallerMethodFactorThreshold:externalCallerMethodFactorThreshold.
		problemsDetected:=methods inject:0 into:[:count :am| (am isABadEncapsulationCandidate)ifTrue: [count+1] ifFalse: [count]].
		Transcript show: problemsDetected asString, String tab.
		externalCallerMethodFactorThreshold:=externalCallerMethodFactorThreshold+0.1.
	].
	Transcript show: String cr.
].! !
